<?php
class ControllerExtensionPaymentBifit extends Controller
{
	private $error = array();

	public function index()
	{
		$this->load->language('extension/payment/bifit');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_bifit', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['token'])) {
			$data['error_token'] = $this->error['token'];
		} else {
			$data['error_token'] = '';
		}

		if (isset($this->error['cashier_name'])) {
			$data['error_cashier_name'] = $this->error['cashier_name'];
		} else {
			$data['error_cashier_name'] = '';
		}

		if (isset($this->error['cashier_inn'])) {
			$data['error_cashier_inn'] = $this->error['cashier_inn'];
		} else {
			$data['error_cashier_inn'] = '';
		}

		if (isset($this->error['payment_address'])) {
			$data['error_payment_address'] = $this->error['payment_address'];
		} else {
			$data['error_payment_address'] = '';
		}

		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true));
		$data['breadcrumbs'][] = array('text' => $this->language->get('text_extension'), 'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
		$data['breadcrumbs'][] = array('text' => $this->language->get('heading_title'), 'href' => $this->url->link('extension/payment/bifit', 'user_token=' . $this->session->data['user_token'], true));
		$data['action'] = $this->url->link('extension/payment/bifit', 'user_token=' . $this->session->data['user_token'], true);
		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		if (isset($this->request->post['payment_bifit_admin'])) {
			$data['payment_bifit_admin'] = $this->request->post['payment_bifit_admin'];
		} else {
			$data['payment_bifit_admin'] = $this->config->get('payment_bifit_admin');
		}

		if (isset($this->request->post['payment_bifit_protect'])) {
			$data['payment_bifit_protect'] = $this->request->post['payment_bifit_protect'];
		} else {
			$data['payment_bifit_protect'] = $this->config->get('payment_bifit_protect');
		}

		if (isset($this->request->post['payment_bifit_test'])) {
			$data['payment_bifit_test'] = $this->request->post['payment_bifit_test'];
		} else {
			$data['payment_bifit_test'] = $this->config->get('payment_bifit_test');
		}

		if (isset($this->request->post['payment_bifit_log'])) {
			$data['payment_bifit_log'] = $this->request->post['payment_bifit_log'];
		} else {
			$data['payment_bifit_log'] = $this->config->get('payment_bifit_log');
		}

		if (isset($this->request->post['payment_bifit_token'])) {
			$data['payment_bifit_token'] = $this->request->post['payment_bifit_token'];
		} else {
			$data['payment_bifit_token'] = $this->config->get('payment_bifit_token');
		}

		if (isset($this->request->post['payment_bifit_cashier_name'])) {
			$data['payment_bifit_cashier_name'] = $this->request->post['payment_bifit_cashier_name'];
		} else {
			$data['payment_bifit_cashier_name'] = $this->config->get('payment_bifit_cashier_name');
		}

		if (isset($this->request->post['payment_bifit_cashier_inn'])) {
			$data['payment_bifit_cashier_inn'] = $this->request->post['payment_bifit_cashier_inn'];
		} else {
			$data['payment_bifit_cashier_inn'] = $this->config->get('payment_bifit_cashier_inn');
		}

		if (isset($this->request->post['payment_bifit_fio'])) {
			$data['payment_bifit_fio'] = $this->request->post['payment_bifit_fio'];
		} else {
			$data['payment_bifit_fio'] = $this->config->get('payment_bifit_fio');
		}

		if (isset($this->request->post['payment_bifit_payment_address'])) {
			$data['payment_bifit_payment_address'] = $this->request->post['payment_bifit_payment_address'];
		} else {
			$data['payment_bifit_payment_address'] = $this->config->get('payment_bifit_payment_address');
		}

		if (isset($this->request->post['payment_bifit_address_type'])) {
			$data['payment_bifit_address_type'] = $this->request->post['payment_bifit_address_type'];
		} else {
			$data['payment_bifit_address_type'] = $this->config->get('payment_bifit_address_type');
		}

		if (isset($this->request->post['payment_bifit_receipt_type'])) {
			$data['payment_bifit_receipt_type'] = $this->request->post['payment_bifit_receipt_type'];
		} else {
			$data['payment_bifit_receipt_type'] = $this->config->get('payment_bifit_receipt_type');
		}

		if (isset($this->request->post['payment_bifit_tax_system'])) {
			$data['payment_bifit_tax_system'] = $this->request->post['payment_bifit_tax_system'];
		} else {
			$data['payment_bifit_tax_system'] = $this->config->get('payment_bifit_tax_system');
		}

		if (isset($this->request->post['payment_bifit_calculation_method'])) {
			$data['payment_bifit_calculation_method'] = $this->request->post['payment_bifit_calculation_method'];
		} else {
			$data['payment_bifit_calculation_method'] = $this->config->get('payment_bifit_calculation_method');
		}

		if (isset($this->request->post['payment_bifit_vat'])) {
			$data['payment_bifit_vat'] = $this->request->post['payment_bifit_vat'];
		} else {
			$data['payment_bifit_vat'] = $this->config->get('payment_bifit_vat');
		}

		if (isset($this->request->post['payment_bifit_vat_mode'])) {
			$data['payment_bifit_vat_mode'] = $this->request->post['payment_bifit_vat_mode'];
		} else {
			$data['payment_bifit_vat_mode'] = $this->config->get('payment_bifit_vat_mode');
		}

		if (isset($this->request->post['payment_bifit_payment_typ'])) {
			$data['payment_bifit_payment_typ'] = $this->request->post['payment_bifit_payment_typ'];
		} else {
			$data['payment_bifit_payment_typ'] = $this->config->get('payment_bifit_payment_typ');
		}

		if (isset($this->request->post['payment_bifit_order_status_id'])) {
			$data['payment_bifit_order_status_id'] = $this->request->post['payment_bifit_order_status_id'];
		} else {
			$data['payment_bifit_order_status_id'] = $this->config->get('payment_bifit_order_status_id');
		}

		if (isset($this->request->post['payment_bifit_payment_method'])) {
			$data['payment_bifit_payment_method'] = $this->request->post['payment_bifit_payment_method'];
		} else {
			$data['payment_bifit_payment_method'] = $this->config->get('payment_bifit_payment_method');
		}

		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		$this->load->model('setting/extension');
		$extensions = $this->model_setting_extension->getInstalled('payment');

		foreach ($extensions as $key => $value)
		{
			if (!is_file(DIR_APPLICATION . 'controller/extension/payment/' . $value . '.php') && !is_file(DIR_APPLICATION . 'controller/payment/' . $value . '.php'))
			{
				$this->model_setting_extension->uninstall('payment', $value);
				unset($extensions[$key]);
			}
		}

		$p_metods = array();

		// Compatibility code for old extension folders
		$files = glob(DIR_APPLICATION . 'controller/extension/payment/*.php');

		if ($files)
		{
			foreach ($files as $file)
			{
				$extension = basename($file, '.php');
				$this->load->language('extension/payment/' . $extension, 'extension');
				$status = $this->config->get('payment_' . $extension . '_status') ? 1 : 0;
				if ($status) {
					$p_metods[] = array('name' => $this->language->get('extension')->get('heading_title'), 'code' => $extension);
				}
			}
		}

		$data['payment_methods'] = $p_metods;

		if (isset($this->request->post['payment_bifit_geo_zone_id'])) {
			$data['payment_bifit_geo_zone_id'] = $this->request->post['payment_bifit_geo_zone_id'];
		} else {
			$data['payment_bifit_geo_zone_id'] = $this->config->get('payment_bifit_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');
		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['payment_bifit_status'])) {
			$data['payment_bifit_status'] = $this->request->post['payment_bifit_status'];
		} else {
			$data['payment_bifit_status'] = $this->config->get('payment_bifit_status');
		}

		if (isset($this->request->post['payment_bifit_sort_order'])) {
			$data['payment_bifit_sort_order'] = $this->request->post['payment_bifit_sort_order'];
		} else {
			$data['payment_bifit_sort_order'] = $this->config->get('payment_bifit_sort_order');
		}

		if (isset($this->request->get['sort'])) {
			$sort = $this->request->get['sort'];
		} else {
			$sort = 'bt.order_id';
		}

		if (isset($this->request->get['order'])) {
			$order = $this->request->get['order'];
		} else {
			$order = 'DESC';
		}

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$data['reports'] = array();
		$filter_data = array(
			'sort'				=> $sort,
			'order'				=> $order,
			'start'				=> ($page - 1) * $this->config->get('config_limit_admin'),
			'limit'				=> $this->config->get('config_limit_admin')
		);
		$this->load->model('extension/payment/bifit');
		$report_total = $this->model_extension_payment_bifit->getTotalTransactions($filter_data);
		$results = $this->model_extension_payment_bifit->getTransactions($filter_data);

		foreach ($results as $result)
		{
			$receipt_link = $result['receipt_link'];
			$data['reports'][] = array(
				'id'			=> $result['bifit_transaction_id'],
				'order_id'      => $result['order_id'],
				'cashier'		=> $result['cashier'],
				'client'		=> $result['client'],
				'receipt_link'  => $receipt_link,
				'receipt_id'	=> $result['receipt_id'],
				'date'          => $result['date'],
				'doc'           => $result['doc'],
				'log'           => $result['log'],
				'receipt_type'	=> $result['receipt_type'],
				'payment_type'	=> $result['payment_type'],
				'view'			=> $this->url->link('extension/payment/bifit/deletetransaction', 'user_token=' . $this->session->data['user_token'] . '&id=' . (int)$result['bifit_transaction_id'], true)
			);
		}

		if (isset($this->request->post['selected'])) {
			$data['selected'] = (array)$this->request->post['selected'];
		} else {
			$data['selected'] = array();
		}

		$url = '';

		if ($order == 'ASC') {
			$url .= '&order=DESC';
		} else {
			$url .= '&order=ASC';
		}

		if (isset($this->request->get['page'])) {
			$url .= '&page=' . $this->request->get['page'];
		}

		$pagination 		= new Pagination();
		$pagination->total 	= $report_total;
		$pagination->page 	= $page;
		$pagination->limit 	= $this->config->get('config_limit_admin');
		$pagination->url 	= $this->url->link('extension/payment/bifit', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}#reportstab', true);
		$data['pagination'] = $pagination->render();
		$data['results'] 	= sprintf($this->language->get('text_pagination'), ($report_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($report_total - $this->config->get('config_limit_admin'))) ? $report_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $report_total, ceil($report_total / $this->config->get('config_limit_admin')));
		$data['user_token'] = $this->session->data['user_token'];

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		$data['header']		 = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer']		 = $this->load->controller('common/footer');
		$this->response->setOutput($this->load->view('extension/payment/bifit', $data));
	}

	public function install()
	{
		if ($this->user->hasPermission('modify', 'marketplace/extension')) {
			$this->load->model('extension/payment/bifit');
			$this->model_extension_payment_bifit->install();
		}
	}

	public function uninstall()
	{
		if ($this->user->hasPermission('modify', 'marketplace/extension')) {
			$this->load->model('extension/payment/bifit');
			$this->model_extension_payment_bifit->uninstall();
		}
	}

	public function deletetransaction()
	{
		if (isset($this->request->get['id'])) {
			$id = (int)$this->request->get['id'];
		} else {
			$id = 0;
		}

		$this->load->model('extension/payment/bifit');
		$this->model_extension_payment_bifit->delete($id);
		$this->response->redirect($this->url->link('extension/payment/bifit', 'user_token=' . $this->session->data['user_token'] , true));
	}

	protected function validate()
	{
		if (!$this->user->hasPermission('modify', 'extension/payment/bifit')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['payment_bifit_token']) {
			$this->error['token'] = $this->language->get('error_token');
		}

		return !$this->error;
	}
}
